package rocks.zipcode.io.quiz3.arrays;

/**
 * @author leon on 09/12/2018.
 */
public class TicTacToe {

    String[][] board;

    public TicTacToe(String[][] board) {
        this.board = board;
    }

    public String[] getRow(Integer value) {
        return board[value];
    }

    public String[] getColumn(Integer value) {
        String[] column = new String[board.length];

        for(int i = 0; i < board.length; i ++){
            String[] row = board[i];
            column[i] = row[value];
        }
        return column;
    }

    public Boolean isRowHomogenous(Integer rowIndex) {
        String[] row = getRow(rowIndex);
        return row[0].equals(row[1]) && row[0].equals(row[2]);    }

    public Boolean isColumnHomogeneous(Integer columnIndex) {
        String[] column = getColumn(columnIndex);
        return column[0].equals(column[1]) && column[0].equals(column[2]);
    }

    public String getWinner() {
        if(getColumnWinner() != null){
            System.out.println("here");
            return getColumnWinner();
        } else if(getRowWinner() != null){
            System.out.println("no Here");
            return getRowWinner();
        } else if(getDiagWinner() != null){
            System.out.println("Here");
            return getDiagWinner();
        } else if(getReverseDiagWinner() != null){
            return getReverseDiagWinner();
        }
        return null;
    }

    public String getRowWinner(){
        int player1 = 0;
        int player2 = 0;
        for(String[] row : board){
            player1 = 0;
            player2 = 0;
            for(String player : row){
                if(player.equals("X")){
                    player1 ++;
                } else {
                    player2 ++;
                }
            }
            if(player1 == 3){
                return "X";
            } else if(player2 == 3){
                return "O";
            }
        }
        return null;
    }

    public String getColumnWinner(){
        int player1 = 0;
        int player2 = 0;
        for(int i = 0; i < board.length; i++){
            String[] column = getColumn(i);
            player1 = 0;
            player2 = 0;
            for(String player : column){
                if(player.equals("X")){
                    player1 ++;
                } else {
                    player2 ++;
                }
            }
            if(player1 == 3){
                return "X";
            } else if(player2 == 3){
                return "O";
            }
        }
        return null;
    }

//    String[] row1 = {"X", "O", "X"};
//    String[] row2 = {"O", "X", "O"};
//    String[] row3 = {"O", "X", "X"};

    public String getDiagWinner(){
        int player1 = 0;
        int player2 = 0;
        int count = 0;
        for(int x = 0; x < board.length; x ++) {
            String[] row = getRow(x);
            for (int i = 0; i < row.length; i++) {
                if(row[i].equals("X") && x == i){
                    count ++;
                    player1 += count;
                    break;
                } else if(row[i].equals("O") && x == i){
                    count ++;
                    player2 += count;
                    break;
                }
            }
            if(player1 == fact(3)){
                return "X";
            } else if(player2 == fact(3)){
                return "O";
            }
        }
        return null;
    }

    public String getReverseDiagWinner(){
        int player1 = 0;
        int player2 = 0;
        int count = 0;
        for(int x = 0; x < board.length; x ++) {
            String[] row = getRow(x);
            for (int i = 0; i < row.length; i++) {
                if(row[i].equals("X") && i == 3 - (count + 1)){
                    count ++;
                    player1 += count;
                    break;
                } else if(row[i].equals("O") && i == 3 - (count + 1)){
                    count ++;
                    player2 += count;
                    break;
                }
            }
            if(player1 == fact(3)){
                return "X";
            } else if(player2 == fact(3)){
                return "O";
            }
        }
        return null;
    }

    int fact( int N )
    {
        int product = 1;
        for ( int j=1; j<=N; j++ )
            product *= j;
        return product;
    }
}
