package rocks.zipcode.io.quiz3.collections;

import rocks.zipcode.io.quiz3.objectorientation.enums.LabStatus;

import java.util.*;
import java.util.stream.Collectors;

/**
 * @author leon on 10/12/2018.
 */
public class Student {

    private Map<Lab, LabStatus> labs;

    public Student() {

        this(new LinkedHashMap<>());
    }

    public Student(Map<Lab, LabStatus> map) {
        this.labs = map;
    }

    public void setLabStatus(Lab lab, LabStatus labStatus) {
        if(lab.isForked()) {
            labs.put(lab, labStatus);
        } else {
            throw new UnsupportedOperationException("The lab has not been forked");
        }
    }


    public void forkLab(Lab lab) {
        lab.setForked(true);
        labs.put(lab, LabStatus.PENDING);

    }

    public LabStatus getLabStatus(String labName) {
        for(Lab lab : labs.keySet()){
            if(lab.getName().equals(labName)){
                return labs.get(lab);
            }
        }
       throw new UnsupportedOperationException("Method not yet implemented");
    }

    @Override
    public String toString() {
        String result = "";
        List<Lab> labList = new ArrayList<>(labs.keySet());
        for(int i = labList.size() - 1; i > -1; i --){
            result += labList.get(i).getName() + " > " + labs.get(labList.get(i)).toString();
            if(i != 0){
                result += "\n";
            }
        }
        return result;
    }
}
